Merge "cloud-init: Upgrade cloud-init to 20.1"
diff --git a/overlay-lakitu/app-emulation/cloud-init/Manifest b/overlay-lakitu/app-emulation/cloud-init/Manifest
index dcc617f..c613182 100644
--- a/overlay-lakitu/app-emulation/cloud-init/Manifest
+++ b/overlay-lakitu/app-emulation/cloud-init/Manifest
@@ -1 +1,2 @@
 DIST cloud-init-19.4.tar.gz 1091893 BLAKE2B 2ab8fef70b420c066d6d8f83871568eeac24f00879ecf3d58c3768dd809cff6a3b79c7e72d9a10204002101049ab86ab64f0c524362e00497a9222960ef380df SHA512 e69ea47eab41d69d64fa44102fbde59319da5f71a68f28a0f6ac65cd6866542b4fe58a71b84c903cfa9b1d2f26eb648cdf4de633b8df61e4f89c9fa4c2a2b1d3
+DIST cloud-init-20.1.tar.gz 1088152 BLAKE2B 1c075676bcf7454965beafaaa38f3cdf08f321ddd0303b7f710c49d2a69e0fb2ec8a81870a632b7504c47af6436555c97ea9fa9c8416955de78f8f551b5509b7 SHA512 ad28e4a0290165308ef2cdb8a935778ad99039978a204bee1098460de006bc3f375a3b81d0d72971fc4f4195d5d2ade9c648fb19e6d6eba12decf750dc54b6eb
diff --git a/overlay-lakitu/app-emulation/cloud-init/cloud-init-20.1-r1.ebuild b/overlay-lakitu/app-emulation/cloud-init/cloud-init-20.1-r1.ebuild
new file mode 120000
index 0000000..1e276a9
--- /dev/null
+++ b/overlay-lakitu/app-emulation/cloud-init/cloud-init-20.1-r1.ebuild
@@ -0,0 +1 @@
+cloud-init-20.1.ebuild
\ No newline at end of file
diff --git a/overlay-lakitu/app-emulation/cloud-init/cloud-init-20.1.ebuild b/overlay-lakitu/app-emulation/cloud-init/cloud-init-20.1.ebuild
new file mode 100644
index 0000000..2aa61df
--- /dev/null
+++ b/overlay-lakitu/app-emulation/cloud-init/cloud-init-20.1.ebuild
@@ -0,0 +1,96 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+PYTHON_COMPAT=( python3_6 python3_7 python3_8 )
+
+inherit distutils-r1
+
+if [[ ${PV} == *9999 ]];then
+	inherit git-r3
+	EGIT_REPO_URI="https://git.launchpad.net/cloud-init"
+else
+	SRC_URI="https://launchpad.net/${PN}/trunk/${PV}/+download/${P}.tar.gz"
+	KEYWORDS="*"
+fi
+
+DESCRIPTION="Cloud instance initialisation magic"
+HOMEPAGE="https://launchpad.net/cloud-init"
+
+LICENSE="GPL-3"
+SLOT="0"
+IUSE="test"
+RESTRICT="!test? ( test )"
+
+CDEPEND="
+	dev-python/jinja[${PYTHON_USEDEP}]
+	dev-python/oauthlib[${PYTHON_USEDEP}]
+	dev-python/pyserial[${PYTHON_USEDEP}]
+	>=dev-python/configobj-5.0.2[${PYTHON_USEDEP}]
+	dev-python/pyyaml[${PYTHON_USEDEP}]
+	dev-python/requests[${PYTHON_USEDEP}]
+	dev-python/jsonpatch[${PYTHON_USEDEP}]
+	dev-python/jsonschema[${PYTHON_USEDEP}]
+	dev-python/six[${PYTHON_USEDEP}]
+"
+DEPEND="
+	dev-python/setuptools[${PYTHON_USEDEP}]
+	test? (
+		${CDEPEND}
+		>=dev-python/httpretty-0.7.1[${PYTHON_USEDEP}]
+		dev-python/mock[${PYTHON_USEDEP}]
+		dev-python/nose[${PYTHON_USEDEP}]
+		dev-python/unittest2[${PYTHON_USEDEP}]
+		dev-python/coverage[${PYTHON_USEDEP}]
+		dev-python/contextlib2[${PYTHON_USEDEP}]
+	)
+"
+RDEPEND="
+	${CDEPEND}
+	net-analyzer/macchanger
+	sys-apps/iproute2
+	sys-fs/growpart
+	virtual/logger
+"
+
+PATCHES=(
+	# Fix Gentoo support
+	# https://code.launchpad.net/~gilles-dartiguelongue/cloud-init/+git/cloud-init/+merge/358777
+	"${FILESDIR}/${PN}-18.4-fix-packages-module.patch"
+	"${FILESDIR}/${PN}-20.1-gentoo-support-upstream-templates.patch"
+	"${FILESDIR}"/18.4-fix-filename-for-storing-locale.patch
+	"${FILESDIR}"/18.4-fix-update_package_sources-function.patch
+	"${FILESDIR}"/18.4-add-support-for-package_upgrade.patch
+)
+
+python_prepare_all() {
+	# Fix location of documentation installation
+	sed -i "s:USR + '/share/doc/cloud-init:USR + '/share/doc/${PF}:" setup.py || die
+	sed -i 's/version=get_version(),/version=9999,/g' setup.py || die
+	distutils-r1_python_prepare_all
+}
+
+python_test() {
+	# Do not use Makefile target as it does not setup environment correclty
+	esetup.py nosetests -v --where cloudinit --where tests/unittests || die
+}
+
+python_install() {
+	distutils-r1_python_install --init-system=sysvinit_openrc,systemd --distro gentoo
+}
+
+python_install_all() {
+	keepdir /etc/cloud
+
+	distutils-r1_python_install_all
+
+	# installs as non-executable
+	chmod +x "${D}"/etc/init.d/*
+}
+
+pkg_postinst() {
+	elog "cloud-init-local needs to be run in the boot runlevel because it"
+	elog "modifies services in the default runlevel.  When a runlevel is started"
+	elog "it is cached, so modifications that happen to the current runlevel"
+	elog "while you are in it are not acted upon."
+}
diff --git a/overlay-lakitu/app-emulation/cloud-init/files/cloud-init-20.1-gentoo-support-upstream-templates.patch b/overlay-lakitu/app-emulation/cloud-init/files/cloud-init-20.1-gentoo-support-upstream-templates.patch
new file mode 100644
index 0000000..c840f4f
--- /dev/null
+++ b/overlay-lakitu/app-emulation/cloud-init/files/cloud-init-20.1-gentoo-support-upstream-templates.patch
@@ -0,0 +1,93 @@
+From 823454f1ea140ec47f5f9c5c3c5ad62eb458eb8a Mon Sep 17 00:00:00 2001
+From: Gilles Dartiguelongue <eva@gentoo.org>
+Date: Wed, 24 Oct 2018 10:52:46 +0200
+Subject: [PATCH 2/5] Add support for gentoo in cloud.cfg and templates
+
+---
+ config/cloud.cfg.tmpl       |  8 ++++++--
+ templates/hosts.gentoo.tmpl | 24 ++++++++++++++++++++++++
+ tools/render-cloudcfg       |  2 +-
+ 3 files changed, 31 insertions(+), 3 deletions(-)
+ create mode 100644 templates/hosts.gentoo.tmpl
+
+diff --git a/config/cloud.cfg.tmpl b/config/cloud.cfg.tmpl
+index 1fef133a..3f5a41a2 100644
+--- a/config/cloud.cfg.tmpl
++++ b/config/cloud.cfg.tmpl
+@@ -134,7 +134,7 @@ cloud_final_modules:
+ # (not accessible to handlers/transforms)
+ system_info:
+    # This will affect which distro class gets used
+-{% if variant in ["amazon", "arch", "centos", "debian", "fedora", "freebsd", "rhel", "suse", "ubuntu"] %}
++{% if variant in ["amazon", "arch", "centos", "debian", "fedora", "freebsd", "gentoo", "rhel", "suse", "ubuntu"] %}
+    distro: {{ variant }}
+ {% else %}
+    # Unknown/fallback distro.
+@@ -172,7 +172,7 @@ system_info:
+          primary: http://ports.ubuntu.com/ubuntu-ports
+          security: http://ports.ubuntu.com/ubuntu-ports
+    ssh_svcname: ssh
+-{% elif variant in ["amazon", "arch", "centos", "fedora", "rhel", "suse"] %}
++{% elif variant in ["amazon", "arch", "centos", "fedora", "gentoo", "rhel", "suse"] %}
+    # Default user name + that default users groups (if added/used)
+    default_user:
+      name: {{ variant }}
+@@ -180,6 +180,10 @@ system_info:
+ {% endif %}
+ {% if variant == "suse" %}
+      groups: [cdrom, users]
++{% elif variant == "gentoo" %}
++     groups: [users, wheel]
++     primary_group: users
++     no_user_group: true
+ {% elif variant == "arch" %}
+      groups: [wheel, users]
+ {% else %}
+diff --git a/templates/hosts.gentoo.tmpl b/templates/hosts.gentoo.tmpl
+new file mode 100644
+index 00000000..cd045fa6
+--- /dev/null
++++ b/templates/hosts.gentoo.tmpl
+@@ -0,0 +1,24 @@
++## template:jinja
++{#
++This file /etc/cloud/templates/hosts.gentoo.tmpl is only utilized
++if enabled in cloud-config.  Specifically, in order to enable it
++you need to add the following to config:
++  manage_etc_hosts: True
++-#}
++# Your system has configured 'manage_etc_hosts' as True.
++# As a result, if you wish for changes to this file to persist
++# then you will need to either
++# a.) make changes to the master file in /etc/cloud/templates/hosts.gentoo.tmpl
++# b.) change or remove the value of 'manage_etc_hosts' in
++#     /etc/cloud/cloud.cfg or cloud-config from user-data
++# 
++# The following lines are desirable for IPv4 capable hosts
++127.0.0.1 {{fqdn}} {{hostname}}
++127.0.0.1 localhost.localdomain localhost
++127.0.0.1 localhost4.localdomain4 localhost4
++
++# The following lines are desirable for IPv6 capable hosts
++::1 {{fqdn}} {{hostname}}
++::1 localhost.localdomain localhost
++::1 localhost6.localdomain6 localhost6
++
+diff --git a/tools/render-cloudcfg b/tools/render-cloudcfg
+index 8b7cb875..d109044e 100755
+--- a/tools/render-cloudcfg
++++ b/tools/render-cloudcfg
+@@ -4,7 +4,7 @@ import argparse
+ import os
+ import sys
+ 
+-VARIANTS = ["amazon", "arch", "centos", "debian", "fedora", "freebsd", "rhel",
+-            "suse", "ubuntu", "unknown"]
++VARIANTS = ["amazon", "arch", "centos", "debian", "fedora", "freebsd",
++            "gentoo", "rhel", "suse", "ubuntu", "unknown"]
+ 
+ if "avoid-pep8-E402-import-not-top-of-file":
+     _tdir = os.path.abspath(os.path.join(os.path.dirname(__file__), ".."))
+-- 
+2.19.1
+
diff --git a/overlay-lakitu/profiles/base/package.mask b/overlay-lakitu/profiles/base/package.mask
index 1ad4d4a..65bf7a2 100644
--- a/overlay-lakitu/profiles/base/package.mask
+++ b/overlay-lakitu/profiles/base/package.mask
@@ -5,3 +5,6 @@
 sys-fs/e2fsprogs::portage-stable
 # Mask audit from chromiumos-overlay
 sys-process/audit::chromiumos
+# Mask cloud-init 20.1 to make sure
+# cloud-init-19.4 still active
+>=app-emulation/cloud-init-20.1